#ifndef GANG_H
#define GANG_H

#include <qwidget.h>
#include <qslider.h>
#include <qlineedit.h>

class Gang : public QObject
{
	Q_OBJECT
public:
	Gang(QSlider* s_, QLineEdit* le_, 
		const float minv_, const float maxv_, 
		const float vv, const bool logs = false);
	
	float v() const { return v_; };
	void setDefault();
	bool changed() const { return changed_; };
	QString flag(const QString f) const;
	QString fname(const QString f) const;
	float p2v(const int p) const;
	int v2p(const float x) const;
public slots:
	void sliderMoved(int p);
	void textChanged();
private:
	QSlider *s;
	QLineEdit *le;
	float minv;
	float maxv;
	float defaultv;
	bool logscaling;
	float v_;
	bool value_from_text;
	bool changed_;
};

#endif
