#ifndef IMAGEVIEWER_H
#define IMAGEVIEWER_H

#include <qmainwindow.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qscrollview.h>
#include <qimage.h>
#include <qprocess.h>
#include "gang.h"

//====================================================================
class ImageViewer : public QScrollView 
{
  Q_OBJECT
public:
	ImageViewer( QWidget *parent=0, const char *name=0 );
	~ImageViewer();
	QSize sizeHint() const;
	void setImage(const QByteArray &buffer);
	bool save(const QString fname);
signals:
	void resizeRequest();
protected slots:
	void pnmReady();
protected:
	void drawContents( QPainter * p, int clipx, int clipy, int clipw, int cliph );
	QImage *image;
	QProcess *pnmproc;
};

//====================================================================
class ImageDialog : public QMainWindow 
{
	Q_OBJECT
public:
	ImageDialog( QWidget *parent=0, const char *name=0 );
	~ImageDialog();
	void setPFS(const QByteArray &pfsin);
	void set(const QByteArray &pfsin, QString cmd, QString args, QString caption, QString fname);
	void startProc(const QByteArray & pfsbuffer, QString cmd, QString args);
protected slots:
	void pfsReady();
	void resizing();
	void setGamma(int value);
	void resetGamma();
	void saveImage();
protected:
	QProcess *pfsproc;
	QByteArray tmbuffer;

	ImageViewer *imageviewer;
	
	QPushButton *savebutton;
	QSlider *gammaslider;
	QLineEdit *gammalineedit;
	Gang *gammagang;
	float curr_gamma;
	
	QLabel *workinglabel;
	
	QString filename;
	
	static int numviewers;
};
#endif

